/*
---------------------------------------
All rights reserved
(C) copyright 2002 Gogul Balakrishnan
---------------------------------------
This is a part of the OS, Gogul is writing currently. Permission to use, copy, modify and distribute this software and documentation is granted without fee, provided this copyright message appears on all distributions.I make no representations of the suitability of the software for any purpose whatsoever. It is provided "as is" without any express or implied warranty.

*/


#include <defs.h>
#include <keyb.h>
#include <io.h>
#include <term.h>


/*
  Lowercase 0
  Uppercase 1
*/
	
	/*{0,ESC,"1234567890-=",BS,HTAB,"qwertyuiop[]",
					ENTER,0,"asdfghjkl;'`",0,0,"zxcvbnm,./",
					0,"*",0," "};
	  {0,ESC,"1234567890_+",BS,HTAB,"QWERTYUIOP{}",
					ENTER,0,"ASDFGHJKL;\"~",0,0,"ZXCVBNM<>?",
					0,"*",0," "};
*/
uchar char_for_scan_code[2][255]={"\0\0331234567890-=\010\011qwertyuiop[]\015\0asdfghjkl;'`\0\0zxcvbnm,./\0*\0 ",
"\0\0331234567890-=\010\011QWERTYUIOP{}\015\0ASDFGHJKL:\"~\0\0ZXCVBNM<>?\0*\0 "};
			
				
char key_pad[]="789-456+1230.";


void print(BYTE key) {
	BYTE *scr=(BYTE *)4;

	__asm__("push %ds");
	asm(" mov %0,%%eax"::"g"(SCR_SEL):"%eax");
	__asm__("mov %eax, %ds");

			 *scr=key;
	
	__asm__("pop %ds");
}

void int_keyb_handler() {
	BYTE scan_code;
	__asm__("push %ds");
	asm("mov %0,%%eax"::"g" (KERNEL_DS_SEL):"%eax");
	__asm__("mov %eax, %ds");
	
	scan_code=inb(KEYB_PORT);
	if(!(scan_code &0x80)) {
		if(scan_code >=F1 && scan_code <=F10)
			switch_terminal(scan_code-F1);
		else
			printk(cur_terminal,char_for_scan_code[0][scan_code]);
	}

	outb(0x20,0x20);
	__asm__("pop %ds
			leave 
			sti
			iret");
}





